
#property copyright "Integer"
#property link      "for-good-letters@yandex.ru"

#property indicator_separate_window
#property indicator_minimum -1
#property indicator_maximum 1
#property indicator_buffers 5
#property indicator_color1 Red
#property indicator_color2 Yellow
#property indicator_color3 Lime
#property indicator_color4 White
#property indicator_color5 Gray

#property indicator_width3 2

//---- input parameters
extern int CorPeriod=14;
extern int MAPeriod=14;
extern int MAMethod=0; // 0-SMA, 1-EMA, 2-SMMA, 3-LWMA
extern int MAPrice=0; // 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
extern int MACDFastPeriod=12;
extern int MACDSlowPeriod=26;
       int MACDSignalPeriod=9;
extern int MACDPrice=0; // 0-Close, 1-Open, 2-High, 3-Low, 4-Median, 5-Typical, 6-Weighted
 
//---- buffers
double cor1[];
double cor2[];
double ind1[];
double ind2[];
double diverpower[];
double Buf1[];
double Buf2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators

   SetLevelValue(0,0.38);
   SetLevelValue(1,-0.38);   
   
   IndicatorBuffers(7);
   
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,cor1);
   
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,cor2);   
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,diverpower);
   
   
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,159);
   SetIndexBuffer(3,Buf1);         
   
   SetIndexStyle(4,DRAW_ARROW);
   SetIndexArrow(4,159);   
   SetIndexBuffer(4,Buf2);    
   
   
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,ind1);
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,ind2);
   
   SetIndexLabel(0,"MA To Line Correlation");
   SetIndexLabel(1,"MACD To Line Correlation");   
   SetIndexLabel(2,"Divergence Power");    
   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start(){

         int limit=Bars-IndicatorCounted();

            for(int i=limit-1;i>=0;i--){
               ind1[i]=iMA(NULL,0,MAPeriod,0,MAMethod,MAPrice,i);
               ind2[i]=iMACD(NULL,0,MACDFastPeriod,MACDSlowPeriod,MACDSignalPeriod,MACDPrice,MODE_MAIN,i);
                  double SXX=0;
                  double SYY=0;
                  double SXY=0;
                  double SumXY=0,SumXX=0,SumYY=0,SumY=0,SumX=0;         
                     for(int j=0;j<CorPeriod;j++){
                        double X=CorPeriod-j;
                        double Y=ind1[i+j];
                        SumXY+=X*Y; 
                        SumXX+=X*X;
                        SumYY+=Y*Y;
                        SumY+=Y;   
                        SumX+=X;  
                     }
                  SXY=CorPeriod*SumXY-SumY*SumX; 
                  SXX=CorPeriod*SumXX-SumX*SumX;
                  SYY=CorPeriod*SumYY-SumY*SumY;
                  cor1[i]=cor1[i+1];
                     if (NormalizeDouble(SXX,8)!=0.0 && NormalizeDouble(SYY,8)!=0){
                        cor1[i]=SXY/(MathSqrt(MathAbs(SXX*SYY)));  
                     }
                       
                  SXX=0;
                  SYY=0;
                  SXY=0;
                  SumXY=0;SumXX=0;SumYY=0;SumY=0;SumX=0;         
                     for(j=0;j<CorPeriod;j++){
                        X=CorPeriod-j;
                        Y=ind2[i+j];
                        SumXY+=X*Y; 
                        SumXX+=X*X;
                        SumYY+=Y*Y;
                        SumY+=Y;   
                        SumX+=X;  
                     }
                  SXY=CorPeriod*SumXY-SumY*SumX; 
                  SXX=CorPeriod*SumXX-SumX*SumX;
                  SYY=CorPeriod*SumYY-SumY*SumY;
                  cor2[i]=cor2[i+1];
                     if (NormalizeDouble(SXX,8)!=0.0 && NormalizeDouble(SYY,8)!=0){
                        cor2[i]=SXY/(MathSqrt(MathAbs(SXX*SYY)));  
                     }  
                     
                  diverpower[i]=(cor1[i]-cor2[i])/2;
                  
                  if((cor1[i]>cor1[i+1] && cor2[i]<cor2[i+1]) || (cor1[i]<cor1[i+1] && cor2[i]>cor2[i+1])){
                     Buf1[i]=0;
                     Buf2[i]=EMPTY_VALUE;                     
                  }
                  else{
                     Buf2[i]=0;
                     Buf1[i]=EMPTY_VALUE;                    
                  }
                  
            }
            
            
   return(0);
  }
//+------------------------------------------------------------------+